<?php
/*
Script to add a new snippet
*/

/**
* bp_code_snippets_insert_code
* Insert a new snippet into a group if the user havent submit one with the same title earlier.
* 
*/
function bp_code_snippets_insert_code($groupid, $userid, $title, $type, $purpose, $content){
	global $wpdb;
	$date_cs = date("Y-m-d H:i:s");
	$table_cs = $wpdb->base_prefix.'code_snippets';
	//faire une requête de vérif sur le titre.
	$check_for_duplicate = $wpdb->get_var("SELECT id_cs FROM ".$table_cs." WHERE id_user='$userid' AND id_group='$groupid' AND snippet_title='$title'");
	if($check_for_duplicate){
		$output_array = array('result'=>0,'ID'=>"duplicate");
	}
	else{
		$insert_snippet = $wpdb->insert($table_cs, array('id_group' => $groupid, 'id_user' => $userid, 'date_cs' => $date_cs, 'snippet_title' => $title, 'snippet_type' => $type, 'snippet_purpose' => $purpose, 'snippet_content' => $content));
		if($insert_snippet){
			$find_id = $wpdb->insert_id;
			$output_array = array('result'=>1,'ID'=>$find_id);

		}else{
			$output_array = array('result'=>0,'ID'=>"none");
		}
	}
	return $output_array;	
}

if(!$bp->groups->current_group->is_user_member){
	$message=__('OOps, you must be part of the group to submit a new snippet!', 'bp-code-snippets');
	$type_message ="error";
}
if($_POST){
	$cs_allowedtags = array(
		'a' => array(
			'href' => array (),
			'title' => array ()),
		'b' => array(),
		'em' => array (), 'i' => array (),
		'strong' => array(),
		'u' => array()
	);
	$type_message = "updated";
	$message = __( 'Your snippet has been correctly added to this group', 'bp-code-snippets' );
	$group_id = (int) $bp->groups->current_group->id;
	$snippet_added = bp_code_snippets_insert_code($group_id, 
												$bp->loggedin_user->id, 
												wp_kses($_POST['snippet_title'],array()),
												$_POST['snippet_type'],
												wp_kses($_POST['snippet_purpose'],$cs_allowedtags),
												wp_specialchars($_POST['snippet_content'])
												);
	if($snippet_added["result"]==0){
		$type_message = "error";
		$message = __('OOps, something went wrong, please try again.', 'bp-code-snippets');
	}
	else{
		$sitewide = true;
		if($bp->groups->current_group->status=="public") $sitewide = false;
		$current_url = $bp->root_domain."/".$bp->current_component."/".$bp->current_item."/".$bp->current_action."/";
		$link_action = '<a href="'.$bp->loggedin_user->domain.'" title="'.$bp->loggedin_user->userdata->user_nicename.'">@'.$bp->loggedin_user->userdata->user_nicename.'</a>'.__('added a snippet','bp-code-snippets');
		$link_content = '<strong>'.wp_kses($_POST['snippet_title'],array()).'</strong>'."\n".'<i>'.__('Excerpt','bp-code-snippets').'</i> : '.substr(wp_kses($_POST['snippet_purpose'],$cs_allowedtags), 0,140)."...\n".'<a href="'.$current_url.'single/'.$snippet_added['ID'].'/" title="'.wp_kses($_POST['snippet_title'],array()).'">'.__('Read more', 'bp-code-snippets').'</a>';
		bp_code_snippets_record_group_activity( array( 'type' => 'activity_update', 'action' => $link_action, 'user_id' => $bp->loggedin_user->id, 'content' => $link_content, 'item_id' => $group_id, 'hide_sitewide' => $sitewide ) );
	}
}
?>
<script type="text/javascript">
	function verif_snippet(){
		if(jQuery("#snippet_content").val().length < 1){
			alert("<?php _e('OOps, You forgot to write some code in your snippet!', 'bp-code-snippets' );?>");
			jQuery("#snippet_content").focus();
			return false;
		}
		if(jQuery("#snippet_title").val().length < 1){
			alert("<?php _e('OOps, please add a title to your snippet!', 'bp-code-snippets' );?>");
			jQuery("#snippet_title").focus();
			return false;
		}
		if(jQuery("#snippet_purpose").val().length < 1){
			alert("<?php _e("OOps, please add a short description of your snippet's goal!", 'bp-code-snippets' );?>");//'
			jQuery("#snippet_purpose").focus();
			return false;
		}
		return true;
	}
</script>
<?php if($message):?>
<div id="message" class="<?php echo $type_message;?> fade"><p><?php echo $message;?></p></div>
<?php endif;?>
<?php if($bp->groups->current_group->is_user_member):?>
<h2><?php _e('Add a new snippet!', 'bp-code-snippets' );?></h2>
<form id="new_snippet" action="" name="new_snippet" method="POST" class="standard-form" onsubmit="return verif_snippet();">
	<label for="snippet_title"><?php _e('Snippet Title', 'bp-code-snippets' );?></label>
	<input type="text" id="snippet_title" name="snippet_title"/>
	<label for="snippet_type"><?php _e('Snippet type', 'bp-code-snippets' );?></label>
	<select id="snippet_type" name="snippet_type">
		<?php echo bp_code_snippets_custom_settings('', 1);?>
	</select>
	<label for="snippet_purpose"><?php _e('Snippet purpose', 'bp-code-snippets' );?>&nbsp;<small><?php _e('(Tags allowed : b, a, em, i, strong, u)','bp-code-snippets');?></small></label>
	<textarea id="snippet_purpose" name="snippet_purpose"></textarea><br/>
	<label for="snippet_content"><?php _e('Your snippet:', 'bp-code-snippets' );?></label>
	<textarea id="snippet_content" name="snippet_content"></textarea><br/>
	<input type="submit" value="<?php _e('Save &amp; Share', 'bp-code-snippets' );?>"/>
</form>
<?php endif;?>