<?php
/*
Script to edit a single code snippets
*/


/*
* bp_code_snippets_update_code
* update a code snippet
*
*/
function bp_code_snippets_update_code($idsnippet, $title, $cat, $purpose, $content){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$snippet_update = $wpdb->update($table_cs, array('snippet_title' => $title, 'snippet_type' => $cat, 'snippet_purpose' => $purpose, 'snippet_content' => $content), array('id_cs'=>$idsnippet));
	return $snippet_update;
}

if(!$bp->groups->current_group->is_user_member){
	$message=__('OOps, you must be part of the group to modify a snippet!','bp-code-snippets');
	$type_message ="error";
}

$id_snippet = (int) $bp->action_variables[1];

if($_POST){
	$cs_allowedtags = array(
		'a' => array(
			'href' => array (),
			'title' => array ()),
		'b' => array(),
		'em' => array (), 'i' => array (),
		'strong' => array(),
		'u' => array()
	);
	$type_message = "updated";
	$message = __( 'Your snippet has been correctly updated', 'bp-code-snippets' );
	$group_id = (int) $bp->groups->current_group->id;
	$snippet_updated = bp_code_snippets_update_code($id_snippet, 
												wp_kses($_POST['snippet_title_mod'],array()),
												$_POST['snippet_type_mod'],
												wp_kses($_POST['snippet_purpose_mod'],$cs_allowedtags),
												wp_specialchars($_POST['snippet_content_mod'])
												);
	if($snippet_updated!=1){
		$type_message = "error";
		$message = __('OOps, something went wrong, please try again.', 'bp-code-snippets');
	}
}
$snippet = bp_code_snippets_single_code($id_snippet,1);
?>
<script type="text/javascript">
	function verif_snippet(){
		if(jQuery("#snippet_content_mod").val().length < 1){
			alert("<?php _e('OOps, You forgot to write some code in your snippet!', 'bp-code-snippets' );?>");
			jQuery("#snippet_content").focus();
			return false;
		}
		if(jQuery("#snippet_title_mod").val().length < 1){
			alert("<?php _e('OOps, please add a title to your snippet!', 'bp-code-snippets' );?>");
			jQuery("#snippet_title").focus();
			return false;
		}
		if(jQuery("#snippet_purpose_mod").val().length < 1){
			alert("<?php _e("OOps, please add a short description of your snippet's goal!", 'bp-code-snippets' );?>");//'
			jQuery("#snippet_purpose").focus();
			return false;
		}
		return true;
	}
</script>
<?php if($message):?>
<div id="message" class="<?php echo $type_message;?> fade"><p><?php echo $message;?></p></div>
<?php endif;?>
<?php if($bp->groups->current_group->is_user_member):?>
<h2><?php _e('Edit your snippet!', 'bp-code-snippets' );?></h2>
<form id="mod_snippet" action="" name="mod_snippet" method="POST" class="standard-form" onsubmit="return verif_snippet();">
	<label for="snippet_title_mod"><?php _e('Snippet Title', 'bp-code-snippets' );?></label>
	<input type="text" id="snippet_title_mod" name="snippet_title_mod" value="<?php echo stripslashes($snippet->snippet_title);?>"/>
	<label for="snippet_type_mod"><?php _e('Snippet type', 'bp-code-snippets' );?></label>
	<select id="snippet_type_mod" name="snippet_type_mod">
		<?php echo bp_code_snippets_custom_settings($snippet->snippet_type, 1);?>
	</select>
	<label for="snippet_purpose_mod"><?php _e('Snippet purpose', 'bp-code-snippets' );?>&nbsp;<small><?php _e('(Tags allowed : b, a, em, i, strong, u)','bp-code-snippets');?></small></label>
	<textarea id="snippet_purpose_mod" name="snippet_purpose_mod"><?php echo stripslashes($snippet->snippet_purpose);?></textarea><br/>
	<label for="snippet_content_mod"><?php _e('Your snippet:', 'bp-code-snippets' );?></label>
	<textarea id="snippet_content_mod" name="snippet_content_mod"><?php echo stripslashes($snippet->snippet_content);?></textarea><br/>
	<input type="submit" name="cs_update" value="<?php _e('Update', 'bp-code-snippets' );?>"/>
</form>
<?php endif;?>