<?php
/*
Script to list code snippets
*/
$group_id = (int) $bp->groups->current_group->id;

/**
* bp_code_snippets_cat_code
* list categories of code
* 
*/
function bp_code_snippets_cat_code($groupid,$current_url=""){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$cat_snippets = $wpdb->get_results("SELECT snippet_type, count(*) as nbre FROM ".$table_cs." WHERE id_group='$groupid' GROUP BY snippet_type");
	?>
	<?php if(count($cat_snippets)>1):?>
	<div id="sub_browse_cat">
		<ul>
			<?php if(!isset($_GET['cat'])):?>
				<li class="current">
			<?php else:?>
				<li>
			<?php endif;?>
			<a href="<?php echo $current_url;?>"><?php _e('Display All', 'bp-code-snippets');?></a></li>
			<?php foreach($cat_snippets as $cat):?>
				<?php if(isset($_GET['cat']) && $_GET['cat'] == $cat->snippet_type):?>
					<li class="current">
				<?php else:?>
					<li>
				<?php endif;?>
					<a href="<?php echo $current_url;?>?cat=<?php echo $cat->snippet_type;?>"><?php echo ucfirst($cat->snippet_type);?> (<?php echo $cat->nbre;?>)</a>
				</li>
			<?php endforeach;?>	
		</ul>
	</div>
	<?php endif;?>
	<?php
}

/**
* bp_code_snippets_num_code
* returns total number of snippets in DB
* 
*/
function bp_code_snippets_num_code($groupid,$query="%",$category="all"){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$comp_request = "";
	if($query!="%"){
		$comp_request = "AND (snippet_title LIKE '%".$query."%' OR snippet_purpose LIKE '%".$query."%' OR snippet_content LIKE '%".$query."%')";
	}
	if($category!="all"){
		$comp_request = "AND snippet_type='".$category."'";
	}
	$num_snippets = $wpdb->get_results("SELECT count(*) as nbre FROM ".$table_cs." WHERE id_group='$groupid' ".$comp_request." ORDER BY date_cs DESC");
	return $num_snippets[0]->nbre;
}

function bp_code_snippets_remove_code($id_snippet){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$removed_snippet = $wpdb->get_results("DELETE FROM ".$table_cs." WHERE id_cs='$id_snippet'");
	return $removed_snippet;
}

/**
* bp_code_snippets_list_code
* Display snippets for a group.
* 
*/
function bp_code_snippets_list_code($groupid, $offset=0, $limit=5){
	global $bp, $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$limit = 5;
	$query="%";
	if($_GET['q']){
		$query = $_GET['q'];
	}
	$comp_request = "";
	if($query!="%"){
		$comp_request = "AND (snippet_title LIKE '%".$query."%' OR snippet_purpose LIKE '%".$query."%' OR snippet_content LIKE '%".$query."%')";
	}
	$category="all";
	if($_GET['cat']){
		$category = $_GET['cat'];
	}
	if($category!="all"){
		$comp_request = "AND snippet_type='".$category."'";
	}
	$current_url = $bp->root_domain."/".$bp->current_component."/".$bp->current_item."/".$bp->current_action."/";
	$paged = 1;
	if(isset($bp->action_variables[0]) && $bp->action_variables[0]=="page"){
		$paged = intval($bp->action_variables[1]);
	}
	if(isset($_GET['paged'])){
		$paged = intval($_GET['paged']);
	}
	if(isset($_GET['delete'])){
		$deleted_code = bp_code_snippets_remove_code($_GET['delete']);
		$type_message = "updated";
		$message = __('Success : the snippet has been removed', 'bp-code-snippets');
	}
	$offset = $limit * ($paged - 1);
	$all_count = bp_code_snippets_num_code($groupid,$query,$category);
	$max_pages = ceil($all_count / $limit);
	$select_snippets = $wpdb->get_results("SELECT id_cs, id_user, date_cs, snippet_title, snippet_type, snippet_purpose, cs_comment_count FROM ".$table_cs." WHERE id_group='$groupid' ".$comp_request." ORDER BY date_cs DESC LIMIT ".$offset.",".$limit);
	?>
	<script type="text/javascript">
	function pleaseconfirm(url){
		c = confirm("<?php _e('Are you sure you want to do this ?','bp-code-snippets');?>");
		if(c){
			location.href=url;
		}
	}
	</script>
	<?php if($message):?>
	<div id="message" class="<?php echo $type_message;?> fade"><p><?php echo $message;?></p></div>
	<?php endif;?>
	<?php if(count($select_snippets)!=0):?>
	<div id="code_snippets_headerbar">
		<div id="sub_search_snippets">
			<form action="<?php echo $current_url;?>" name="search_snippet" method="get" class="standard-form">
				<input type="text" name="q" id="search_query" style="width:150px"  value="<?php if($_GET['q']) echo $_GET['q']; else _e('Find a snippet', 'bp-code-snippets');?>" onclick="javascript:this.value=''"/>
			</form>
		</div>
		<?php bp_code_snippets_cat_code($groupid, $current_url);?>
	</div>
	<div id="snippet_list">
	<?php foreach($select_snippets as $snippet){
		$user_info = get_userdata($snippet->id_user);
		?>
		<div class="item-cs" id="cs_<?php echo $snippet->id_cs;?>">
			<div class="avatar-cs-author">
				<a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" title="<?php echo $user_info->user_nicename;?>" rel="nofollow">
				<?php echo bp_core_fetch_avatar('item_id=' . $snippet->id_user . '&type=full&width=64&height=64' ) ?>
				</a>
			<span class="cs-comment-num"><a href="<?php echo $current_url;?>single/<?php echo $snippet->id_cs;?>/" title="<?php echo $snippet->cs_comment_count;?> <?php _e('comment(s)', 'bp-code-snippets');?>"><?php echo $snippet->cs_comment_count;?></a></span>
			</div>
			<div class="item-cs-desc">
			<div class="cs_meta"><span class="highlight"><?php _e('Added by', 'bp-code-snippets');?> <a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" rel="nofollow">@<?php echo $user_info->user_nicename;?></a></span>&nbsp;<?php _e('on', 'bp-code-snippets');?> <?php echo mysql2date(get_option('date_format'), $snippet->date_cs);?>&nbsp;<?php _e('at', 'bp-code-snippets');?>&nbsp;<?php echo mysql2date(get_option('time_format'), $snippet->date_cs);?> <?php _e('in category', 'bp-code-snippets');?> <a href="<?php echo $current_url;?>?cat=<?php echo $snippet->snippet_type;?>"><img src="<?php echo BP_CS_PLUGIN_URL;?>/images/<?php echo $snippet->snippet_type;?>.gif" alt="<?php echo $snippet->snippet_type;?>"/>&nbsp;<i><?php echo strtoupper($snippet->snippet_type);?></i></a>
			</div>
			<div class="cs-content">
				<h3><a href="<?php echo $current_url;?>single/<?php echo $snippet->id_cs;?>/" title="<?php _e('Read more', 'bp-code-snippets');?>"><?php echo stripslashes($snippet->snippet_title);?></a>
					<?php if(($bp->loggedin_user->id==$snippet->id_user && $snippet->cs_comment_count==0) || bp_group_is_mod() || bp_group_is_admin()):?>
					&nbsp;<span class="edit-cs"><a href="<?php echo $current_url;?>edit/<?php echo $snippet->id_cs;?>/" title="<?php _e('Edit', 'bp-code-snippets');?>"><?php _e('Edit', 'bp-code-snippets');?></a>&nbsp;<a href="javascript:pleaseconfirm('<?php echo $current_url;?>?delete=<?php echo $snippet->id_cs;?>');" title="<?php _e('Delete', 'bp-code-snippets');?>"><?php _e('Delete', 'bp-code-snippets');?></a></span>
					<?php endif;?>
				</h3>
				<p><?php echo substr(stripslashes($snippet->snippet_purpose), 0,250);?>
				<?php if(strlen(stripslashes($snippet->snippet_purpose))>250):?>
					&nbsp;... <a href="<?php echo $current_url;?>single/<?php echo $snippet->id_cs;?>/" title="<?php echo $snippet->snippet_title;?>"><?php _e('Read more', 'bp-code-snippets');?></a>
				<?php endif;?>	
				</p>
			</div>
			</div>
		</div>
	<?php
		}
	?>
	<?php if(isset($_GET['q']) || isset($_GET['cat'])):?>
		<div class="bp-cs-pagination">

		   <?php
		    $page_links = paginate_links( array(
		        'base' => add_query_arg( 'paged', '%#%' ),
		        'format' => '',
		        'prev_text' => __('&laquo;'),
		        'next_text' => __('&raquo;'),
		        'total' => $max_pages,
		        'current' => $paged
		     ));
		    ?>

		<?php if ( $page_links ) { ?>
			<div class="pagination-links-cs"><?php $page_links_text = sprintf( '<span class="displaying-num">' . __( 'Displaying %s&#8211;%s of %s' ) . '</span>%s',
			number_format_i18n( $offset+1 ),
			number_format_i18n( $offset + count($select_snippets) ),
			number_format_i18n( $all_count ),
			$page_links
		); echo $page_links_text."</div>"; ?>

		<?php } ?>
		</div>
	<?php else:?>
	<div class="bp-cs-pagination">

	   <?php
	    $page_links = paginate_links( array(
	        'base' => $current_url.'%_%',
	        'format' => 'page/%#%/',
	        'prev_text' => __('&laquo;'),
	        'next_text' => __('&raquo;'),
	        'total' => $max_pages,
	        'current' => $paged
	     ));
	    ?>

	<?php if ( $page_links ) { ?>
		<div class="pagination-links-cs"><?php $page_links_text = sprintf( '<span class="displaying-num">' . __( 'Displaying %s&#8211;%s of %s' ) . '</span>%s',
		number_format_i18n( $offset+1 ),
		number_format_i18n( $offset + count($select_snippets) ),
		number_format_i18n( $all_count ),
		$page_links
	); echo $page_links_text."</div>"; ?>

	<?php } ?>
	</div>
	<?php endif;?>
	</div>
	<?php else:?>
		<p><a href="<?php echo $current_url;?>add/"><?php _e('No snippets yet for this group. Be the first to add one!', 'bp-code-snippets');?></a></p>
	<?php endif;?>
	<?php
}
bp_code_snippets_list_code($group_id);
?>