<?php

/**
* bp_code_snippets_action_member_feed
* Registers the template for the member public snippets rss feed
* 
*/
function bp_code_snippets_action_member_feed() {
	global $bp, $wp_query;

	if ( $bp->current_component != $bp->snippets->slug || $bp->current_action != 'member-feed' )
		return false;

	$wp_query->is_404 = false;
	status_header( 200 );

	include_once( 'feeds/member-snippets.php' );
	die();
}
add_action( 'bp_init', 'bp_code_snippets_action_member_feed', 8 );

/**
* bp_member_bp_code_snippets_feed_link
* Display the rss feed for the member public snippets.
* 
*/
function bp_member_bp_code_snippets_feed_link() {
	echo bp_get_member_bp_code_snippets_feed_link();
}
	function bp_get_member_bp_code_snippets_feed_link() {
		global $bp;
		return apply_filters( 'bp_member_bp_code_snippets_feed_link', $bp->displayed_user->domain . $bp->snippets->slug . '/member-feed'  );
	}

/**
* bp_code_snippets_set_member_nav
* add snippets navigation to member view
*
*/
function bp_code_snippets_set_member_nav(){
	global $bp;

	/* Add 'My Snippets' to the main user profile navigation */
	bp_core_new_nav_item( array(
		'name' => __( 'Snippets', 'bp-code-snippets' ).' ('.bp_code_snippets_num_active_user($bp->displayed_user->id).')',
		'slug' => BP_CS_SLUG,
		'position' => 80,
		'screen_function' => 'bp_code_snippets_member_home',
		'default_subnav_slug' => 'listing'
	) );

	$bp_cs_link = $bp->loggedin_user->domain . BP_CS_SLUG . '/';

	/* Create a sub nav item for this component */
	bp_core_new_subnav_item( array(
		'name' => __( 'Listing of my latest(s) snippets', 'bp-code-snippets' ),
		'slug' => 'listing',
		'parent_slug' => BP_CS_SLUG,
		'parent_url' => $bp_cs_link,
		'screen_function' => 'bp_code_snippets_member_home',
		'position' => 10
	) );
}
add_action( 'wp', 'bp_code_snippets_set_member_nav', 2 );
add_action( 'admin_menu', 'bp_code_snippets_set_member_nav', 2 );

/**
* bp_code_snippets_list_code_for_active_user
* Display snippets for a user.
* 
*/
function bp_code_snippets_list_code_for_active_user(){
	global $bp, $wpdb;
	$user_id = $bp->displayed_user->id;
	$paged = 1;
	if(isset($_GET['paged'])){
		$paged = intval($_GET['paged']);
	}
	$limit=5;
	$offset=0;
	$offset = $limit * ($paged - 1);
	$all_count = bp_code_snippets_num_active_user($user_id);
	$max_pages = ceil($all_count / $limit);
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$user_snippets = $wpdb->get_results("SELECT id_cs, id_group, id_user, date_cs, snippet_title, snippet_type, snippet_purpose, cs_comment_count FROM ".$table_cs." WHERE id_user='$user_id' ORDER BY date_cs DESC LIMIT ".$offset.",".$limit);
	?>
	<div id="snippet_list">
	<?php foreach($user_snippets as $snippet){
		$user_info = get_userdata($snippet->id_user);
		$group_info = bp_code_snippet_get_infos_goup($snippet->id_group);
		$group_permalink = site_url().'/'.BP_GROUPS_SLUG.'/'.$group_info->slug.'/';
		$snippet_permalink = $group_permalink.BP_CS_SLUG.'/';
		if(groups_is_user_member( $bp->loggedin_user->id, $snippet->id_group ) || $bp->loggedin_user->id==$snippet->id_user || $group_info->status == 'public'){
		?>
		<div class="item-cs" id="cs_<?php echo $snippet->id_cs;?>">
			<div class="avatar-cs-author">
				<a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" title="<?php echo $user_info->user_nicename;?>" rel="nofollow">
				<?php echo bp_core_fetch_avatar('item_id=' . $snippet->id_user . '&type=full&width=64&height=64' ) ?>
				</a>
			<span class="cs-comment-num"><a href="<?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?>/" title="<?php echo $snippet->cs_comment_count;?> <?php _e('comment(s)', 'bp-code-snippets');?>"><?php echo $snippet->cs_comment_count;?></a></span>
			</div>
			<div class="item-cs-desc">
			<div class="cs_meta"><span class="highlight"><?php _e('Added by', 'bp-code-snippets');?> <a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" rel="nofollow">@<?php echo $user_info->user_nicename;?></a></span>&nbsp;<?php _e('on', 'bp-code-snippets');?> <?php echo mysql2date(get_option('date_format'), $snippet->date_cs);?>&nbsp;<?php _e('at', 'bp-code-snippets');?>&nbsp;<?php echo mysql2date(get_option('time_format'), $snippet->date_cs);?> <?php _e('in category', 'bp-code-snippets');?> 
			<?php if(groups_is_user_member( $bp->loggedin_user->id, $snippet->id_group )):?>
				<a href="<?php echo $snippet_permalink;?>?cat=<?php echo $snippet->snippet_type;?>"><img src="<?php echo BP_CS_PLUGIN_URL;?>/images/<?php echo $snippet->snippet_type;?>.gif" alt="<?php echo $snippet->snippet_type;?>"/>&nbsp;<i><?php echo strtoupper($snippet->snippet_type);?></i></a>
				<?php else:?>
					<img src="<?php echo BP_CS_PLUGIN_URL;?>/images/<?php echo $snippet->snippet_type;?>.gif" alt="<?php echo $snippet->snippet_type;?>"/>&nbsp;<i><?php echo strtoupper($snippet->snippet_type);?></i>
				<?php endif;?>
				 <?php _e('of the group', 'bp-code-snippets');?> <i><a href="<?php echo $group_permalink;?>" title="<?php _e('Go to group ', 'bp-code-snippets').$group_info->name;?>"><?php echo $group_info->name;?></a></i>
			</div>
			<div class="cs-content">
				<h3>
					<?php if(groups_is_user_member( $bp->loggedin_user->id, $snippet->id_group )):?>
						<a href="<?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?>/" title="<?php _e('Read more', 'bp-code-snippets');?>"><?php echo stripslashes($snippet->snippet_title);?></a>
					<?php else:?>
						<?php echo stripslashes($snippet->snippet_title);?>
					<?php endif;?>
				</h3>
				<p><?php echo substr(stripslashes($snippet->snippet_purpose), 0,250);?>
				<?php if(strlen(stripslashes($snippet->snippet_purpose))>250):?>
					&nbsp;... 
					<?php if(groups_is_user_member( $bp->loggedin_user->id, $snippet->id_group )):?>
					<a href="<?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?>/" title="<?php echo $snippet->snippet_title;?>"><?php _e('Read more', 'bp-code-snippets');?></a>
					<?php endif;?>
				<?php endif;?>	
				</p>
			</div>
			</div>
		</div>
<?php
		}
	}
?>
	</div>
	<div class="bp-cs-pagination">

	   <?php
	    $page_links = paginate_links( array(
	        'base' => add_query_arg( 'paged', '%#%' ),
	        'format' => '',
	        'prev_text' => __('&laquo;'),
	        'next_text' => __('&raquo;'),
	        'total' => $max_pages,
	        'current' => $paged
	     ));
	    ?>

	<?php if ( $page_links ) { ?>
		<div class="pagination-links-cs"><?php $page_links_text = sprintf( '<span class="displaying-num">' . __( 'Displaying %s&#8211;%s of %s' ) . '</span>%s',
		number_format_i18n( $offset+1 ),
		number_format_i18n( $offset + count($user_snippets) ),
		number_format_i18n( $all_count ),
		$page_links
	); echo $page_links_text."</div>"; ?>

	<?php } ?>
	</div>
	<?php
}



/********************************************************************************
 * Screen Functions
 */

/**
 * bp_code_snippets_member_home()
 *
 * Sets up and displays the screen output for the sub nav item "example/screen-one"
 */
function bp_code_snippets_member_home() {
	global $bp;
	wp_enqueue_style('code_snippets_style', BP_CS_PLUGIN_URL . '/css/bp-cs.css');
	//check for pagination !!
	
	/* Add a do action here, so the component can be extended by others. */
	do_action( 'bp_code_snippets_template_member_home' );
	bp_core_load_template( apply_filters( 'bp_code_snippets_template_member_home', 'code-snippets/my-home' ) );

}
?>