<?php

/**
* bp_snippets_get_last_updated
* answers to what is the date of the latest snippet ?
* 
*/
function bp_snippets_get_last_updated(){
	global $bp, $wpdb;
	$last_updated = $wpdb->get_var("SELECT date_cs FROM ".$bp->snippets->table_name_snippets." ORDER BY date_cs DESC LIMIT 1");
	return $last_updated;
}

/**
* bp_code_snippets_list_public_rss_items
* list all the public snippets of the website.
* 
*/
function bp_code_snippets_list_public_rss_items(){
	global $bp, $wpdb;
	$public_dir_snippets_rss = $wpdb->get_results("SELECT id_cs, id_group, id_user, date_cs, snippet_title, snippet_purpose FROM ".$bp->snippets->table_name_snippets." LEFT JOIN ".$wpdb->base_prefix."bp_groups ON(".$bp->snippets->table_name_snippets.".id_group = ".$wpdb->base_prefix."bp_groups.id) WHERE ".$wpdb->base_prefix."bp_groups.status='public' ORDER BY date_cs DESC LIMIT 20");
	?>
	<?php
	if(count($public_dir_snippets_rss)>0){
	foreach($public_dir_snippets_rss as $snippet){
		$user_info = get_userdata($snippet->id_user);
		$group_info = bp_code_snippet_get_infos_goup($snippet->id_group);
		$group_permalink = site_url().'/'.BP_GROUPS_SLUG.'/'.$group_info->slug.'/';
		$snippet_permalink = $group_permalink.BP_CS_SLUG.'/';
		?>
		<item>
			<guid><?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?></guid>
			<title><?php echo stripslashes($snippet->snippet_title);?></title>
			<link><?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?></link>
			<pubDate><?php echo mysql2date('D, d M Y H:i:s O', $snippet->date_cs, false ); ?></pubDate>
			<dc:creator><?php echo $user_info->user_nicename;?></dc:creator>
			<description><![CDATA[<?php echo substr(stripslashes($snippet->snippet_purpose), 0,250);?>]]></description>
		</item>
	<?php
	}
	}
	else{
		?>
		<item><title><?php _e( 'No Snippet yet!', 'bp-code-snippets' ) ?></title></item>
		<?php
	}
}

/**
* bp_snippets_get_group_last_updated
* retrieves the date of the latest snippet for a group.
* 
*/
function bp_snippets_get_group_last_updated(){
	global $bp, $wpdb;
	$group_id = (int) $bp->groups->current_group->id;
	$last_updated = $wpdb->get_var("SELECT date_cs FROM ".$bp->snippets->table_name_snippets." WHERE id_group='$group_id' ORDER BY date_cs DESC LIMIT 1");
	return $last_updated;
}

/**
* bp_code_snippets_list_group_rss_items
* list all public snippets for a group.
* 
*/
function bp_code_snippets_list_group_rss_items(){
	global $bp, $wpdb;
	$group_id = (int) $bp->groups->current_group->id;
	$group_snippets_rss = $wpdb->get_results("SELECT id_cs, id_group, id_user, date_cs, snippet_title, snippet_purpose FROM ".$bp->snippets->table_name_snippets." WHERE id_group='$group_id' ORDER BY date_cs DESC LIMIT 20");
	?>
	<?php
	if(count($group_snippets_rss)>0){
	foreach($group_snippets_rss as $snippet){
		$user_info = get_userdata($snippet->id_user);
		$group_permalink = site_url().'/'.BP_GROUPS_SLUG.'/'.$bp->groups->current_group->slug.'/';
		$snippet_permalink = $group_permalink.BP_CS_SLUG.'/';
		?>
		<item>
			<guid><?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?></guid>
			<title><?php echo stripslashes($snippet->snippet_title);?></title>
			<link><?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?></link>
			<pubDate><?php echo mysql2date('D, d M Y H:i:s O', $snippet->date_cs, false ); ?></pubDate>
			<dc:creator><?php echo $user_info->user_nicename;?></dc:creator>
			<description><![CDATA[<?php echo substr(stripslashes($snippet->snippet_purpose), 0,250);?>]]></description>
		</item>
	<?php
	}
	}
	else{
		?>
		<item><title><?php _e( 'No Snippet for this group yet!', 'bp-code-snippets' ) ?></title></item>
		<?php
	}
}

/**
* bp_snippets_get_single_last_updated
* gives the date of the latest comment for a snippet or the birth day of the snippet.
* 
*/
function bp_snippets_get_single_last_updated(){
	global $bp, $wpdb;
	$snippet_id = (int) $bp->action_variables[1];
	$last_updated = $wpdb->get_row("SELECT date_cs, date_comment FROM ".$bp->snippets->table_name_snippets." LEFT JOIN ".$bp->snippets->table_name_comments." ON(".$bp->snippets->table_name_snippets.".id_cs=".$bp->snippets->table_name_comments.".cs_id) WHERE id_cs='$snippet_id' ORDER BY date_comment DESC LIMIT 1");
	if(!$last_updated->date_comment){
		return $last_updated->date_cs;
	}
	else return $last_updated->date_comment;
}

/**
* bp_snippets_get_single_title
* gives the date of the latest comment for a snippet.
* 
*/
function bp_snippets_get_single_title($id){
	global $bp, $wpdb;
	$snippet_id = (int) $id;
	$title_snippets_rss = $wpdb->get_var("SELECT snippet_title FROM ".$bp->snippets->table_name_snippets." WHERE id_cs='$snippet_id'");
	return stripslashes($title_snippets_rss);
}

/**
* bp_code_snippets_list_comments_rss_items
* retrieves all the comments of a snippet.
* 
*/
function bp_code_snippets_list_comments_rss_items(){
	global $bp, $wpdb;
	$snippet_id = (int) $bp->action_variables[1];
	$comments_snippets_rss = $wpdb->get_results("SELECT * FROM ".$bp->snippets->table_name_comments." WHERE cs_id='$snippet_id' ORDER BY date_comment DESC LIMIT 20");
	?>
	<?php if(count($comments_snippets_rss)>0){
		foreach($comments_snippets_rss as $snippet){
		$user_info = get_userdata($snippet->user_id);
		$group_permalink = site_url().'/'.BP_GROUPS_SLUG.'/'.$bp->groups->current_group->slug.'/';
		$snippet_permalink = $group_permalink.BP_CS_SLUG.'/single/'.$snippet_id.'/#cs-comment-'.$snippet->id_cs_comment;
		?>
		<item>
			<guid><?php echo $snippet_permalink;?></guid>
			<title><?php echo $user_info->user_nicename;?> <?php _e( 'commented', 'bp-code-snippets' ) ?></title>
			<link><?php echo $snippet_permalink;?></link>
			<pubDate><?php echo mysql2date('D, d M Y H:i:s O', $snippet->date_comment, false ); ?></pubDate>
			<dc:creator><?php echo $user_info->user_nicename;?></dc:creator>
			<description><![CDATA[<?php echo substr(stripslashes($snippet->comment_content), 0,400);?>]]></description>
		</item>
	<?php
		}
	}
	else{
		?>
		<item><title><?php _e( 'No comment yet!', 'bp-code-snippets' ) ?></title></item>
		<?php
	}
}

/**
* bp_snippets_get_member_last_updated
* give the date of the latest snippet added by a user.
* 
*/
function bp_snippets_get_member_last_updated(){
	global $bp, $wpdb;
	$last_updated = $wpdb->get_var("SELECT date_cs FROM ".$bp->snippets->table_name_snippets." WHERE id_user='".$bp->displayed_user->id."' ORDER BY date_cs DESC LIMIT 1");
	return $last_updated;
}

/**
* bp_code_snippets_list_member_public_rss_items
* retrieves all the public snippets of a user.
* 
*/
function bp_code_snippets_list_member_public_rss_items(){
	global $bp, $wpdb;
	$public_member_snippets_rss = $wpdb->get_results("SELECT id_cs, id_group, id_user, date_cs, snippet_title, snippet_purpose FROM ".$bp->snippets->table_name_snippets." LEFT JOIN ".$wpdb->base_prefix."bp_groups ON(".$bp->snippets->table_name_snippets.".id_group = ".$wpdb->base_prefix."bp_groups.id) WHERE ".$wpdb->base_prefix."bp_groups.status='public' AND id_user='".$bp->displayed_user->id."' ORDER BY date_cs DESC LIMIT 20");
	?>
	<?php
	if(count($public_member_snippets_rss)>0){
	foreach($public_member_snippets_rss as $snippet){
		$user_info = get_userdata($snippet->id_user);
		$group_info = bp_code_snippet_get_infos_goup($snippet->id_group);
		$group_permalink = site_url().'/'.BP_GROUPS_SLUG.'/'.$group_info->slug.'/';
		$snippet_permalink = $group_permalink.BP_CS_SLUG.'/';
		?>
		<item>
			<guid><?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?></guid>
			<title><?php echo stripslashes($snippet->snippet_title);?></title>
			<link><?php echo $snippet_permalink;?>single/<?php echo $snippet->id_cs;?></link>
			<pubDate><?php echo mysql2date('D, d M Y H:i:s O', $snippet->date_cs, false ); ?></pubDate>
			<dc:creator><?php echo $user_info->user_nicename;?></dc:creator>
			<description><![CDATA[<?php echo substr(stripslashes($snippet->snippet_purpose), 0,250);?>]]></description>
		</item>
	<?php
	}
	}
	else{
		?>
		<item><title><?php _e( 'No Snippet for this member yet!', 'bp-code-snippets' ) ?></title></item>
		<?php
	}
}
?>