<?php
/*
Script to display a single code snippets
*/
$id_snippet = (int) $bp->action_variables[1];
$snippet = bp_code_snippets_single_code($id_snippet,1);
$user_info = get_userdata($snippet->id_user);
$paged = 1;

/**
* bp_code_snippets_single_add_comment
* save new comment on a snippet
* 
*/
function bp_code_snippets_single_add_comment($id_snippet, $id_user, $content, $comment_count=0){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$table_cs_comments = $wpdb->base_prefix.'code_snippets_comments';
	$comment_date = date("Y-m-d H:i:s");
	//check 4 comments
	$check_cs_comment = $wpdb->get_var("SELECT id_cs_comment FROM ".$table_cs_comments." WHERE user_id = '$id_user' AND cs_id='$id_snippet' AND ADDTIME(date_comment,'0 0:0:30') > '$comment_date'");
	if($check_cs_comment){
		$output_array = array('result'=>2,'ID'=>$check_cs_comment);
	}
	else{
		$wpdb->insert($table_cs_comments, array('cs_id'=>$id_snippet, 'user_id' => $id_user, 'date_comment' => $comment_date, 'comment_content' => $content));
		$comment_id = $wpdb->insert_id;
		if($comment_id){
			$output_array = array('result'=>1,'ID'=>$comment_id);
		}
		else{
			$output_array = array('result'=>0,'ID'=>'none');
		}
	}
	if($output_array['result']==1){
		$num_comment = (int) $comment_count+1;
		$snippet_update = $wpdb->update($table_cs, array('cs_comment_count' => $num_comment), array('id_cs'=>$id_snippet));
	}
	return $output_array;
}

/**
* bp_code_snippets_remove_comment
* if user is admin or mod, remove the comment.
* 
*/
function bp_code_snippets_remove_comment($comment_id, $comment_count, $id_snippet){
	global $wpdb;
	$table_cs = $wpdb->base_prefix.'code_snippets';
	$table_cs_comments = $wpdb->base_prefix.'code_snippets_comments';
	$remove_comment = $wpdb->get_results("DELETE FROM ".$table_cs_comments." WHERE id_cs_comment='$comment_id'");
	$num_comment = (int) $comment_count-1;
	$snippet_update = $wpdb->update($table_cs, array('cs_comment_count' => $num_comment), array('id_cs'=>$id_snippet));
	return $snippet_update;
}

/**
* bp_code_snippets_sanitize_comment
* clean comment content from not allowed tags and add pre tags with the correct brush type
* 
*/
function bp_code_snippets_sanitize_comment($c, $type){
	$cs_allowedtags = array(
		'a' => array(
			'href' => array (),
			'title' => array ()),
		'b' => array(),
		'em' => array (), 'i' => array (),
		'strong' => array(),
		'u' => array()
	);

	preg_match_all('#\[pre\](.*)\[\/pre\]#sU', $c, $matches);
	$replacement=array();
	$the_comment="";
	foreach($matches[1] as $pr){
		$replacement[]=wp_specialchars($pr);
	}
	$comment = preg_split('#\[pre\](.*)\[\/pre\]#sU', $c);
	if(count($comment)<count($replacement)){
		$length = count($replacement);
	}
	else{
		$length = count($comment);
	}
	for($i=0;$i<$length;$i++){
		if($comment[$i]) $the_comment.= wp_kses($comment[$i],$cs_allowedtags);
		if($replacement[$i]) $the_comment.= "\n".'<div class="code_in_content"><pre class="brush: '.$type.'">'.$replacement[$i].'</pre></div>'."\n";
	}
	return $the_comment;
}

/**
* bp_code_snippets_num_comments
* returns total number of comments for pagination
* 
*/
function bp_code_snippets_num_comments($id_snippet){
	global $wpdb;
	$table_cs_comments = $wpdb->base_prefix.'code_snippets_comments';
	$num_comments = $wpdb->get_var("SELECT count(*) as nbre FROM ".$table_cs_comments." WHERE cs_id='$id_snippet' ORDER BY date_comment DESC");
	return $num_comments;
}

/**
* bp_code_snippets_single_list_comments
* display all comments for the selected snippet
* 
*/
function bp_code_snippets_single_list_comments($id_snippet, $paged=1){
	global $bp,$wpdb;
	$table_cs_comments = $wpdb->base_prefix.'code_snippets_comments';
	$limit=5;
	$offset = $limit * ($paged - 1);
	$all_count = bp_code_snippets_num_comments($id_snippet);
	$max_pages = ceil($all_count / $limit);
	$select_snippet_comments = $wpdb->get_results("SELECT * FROM ".$table_cs_comments." WHERE cs_id='$id_snippet' ORDER BY date_comment DESC LIMIT ".$offset.",".$limit);
	$current_url = $bp->root_domain."/".$bp->current_component."/".$bp->current_item."/".$bp->current_action."/".$bp->action_variables[0]."/".$bp->action_variables[1]."/";
	?>
	<?php if(count($select_snippet_comments)==0):?>
		<?php _e('No comment for this snippet, be the first to add one!','bp-code-snippets');?>
	<?php else:?>
		<?php 
		foreach($select_snippet_comments as $comment){
			$user_info = get_userdata($comment->user_id);
		?>
		<div class="snippet-comment"><a name="cs-comment-<?php echo $comment->id_cs_comment;?>"></a>
		<div class="avatar-cs-author">
			<a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" title="<?php echo $user_info->user_nicename;?>" rel="nofollow">
			<?php echo bp_core_fetch_avatar('item_id=' . $comment->user_id . '&type=full&width=32&height=32' ) ?>
			</a>
		</div>
		<div class="cs-comment-meta"><span class="highlight"><?php _e('Added by','bp-code-snippets');?> <a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" rel="nofollow">@<?php echo $user_info->user_nicename;?></a></span>&nbsp;<?php _e('on', 'bp-code-snippets');?> <?php echo mysql2date(get_option('date_format'), $comment->date_comment);?>&nbsp;<?php _e('at', 'bp-code-snippets');?>&nbsp;<?php echo mysql2date(get_option('time_format'), $comment->date_comment);?>
			<?php if(bp_group_is_mod() || bp_group_is_admin()):?>
			&nbsp;<span class="edit-cs"><a href="javascript:pleaseconfirm('<?php echo $current_url;?>?del_com=<?php echo $comment->id_cs_comment;?>');" title="<?php _e('Delete','bp-code-snippets');?>"><?php _e('Delete','bp-code-snippets');?></a></span>
			<?php endif;?>
		</div>
		<div class="cs-comment-content">
			<?php echo convert_smilies(stripslashes($comment->comment_content));?>
		</div>
		</div>
		<?php
		}
		?>
		<div class="bp-cs-pagination">

		   <?php
		    $page_links = paginate_links( array(
		        'base' => add_query_arg( 'paged', '%#%' ),
		        'format' => '',
		        'prev_text' => __('&laquo;'),
		        'next_text' => __('&raquo;'),
		        'total' => $max_pages,
		        'current' => $paged
		     ));
		    ?>

		<?php if ( $page_links ) { ?>
			<div class="pagination-links-cs"><?php $page_links_text = sprintf( '<span class="displaying-num">' . __( 'Displaying %s&#8211;%s of %s' ) . '</span>%s',
			number_format_i18n( $offset+1 ),
			number_format_i18n( $offset + count($select_snippet_comments) ),
			number_format_i18n( $all_count ),
			$page_links
		); echo $page_links_text."</div>"; ?>

		<?php } ?>
		</div>
	<?php endif;?>
	<?php
}

/* Only group members can comment! */
if(!$bp->groups->current_group->is_user_member){
	$message=__('OOps, only group members can comment, please join this group!', 'bp-code-snippets');
	$type_message ="error";
}

/* Saving new comment */
if($_POST['save_comment']){
	$comment = bp_code_snippets_sanitize_comment($_POST['snippet_comment'], $_POST['pre-type']);
	$type_message = "updated";
	$message = __( 'Success : your comment has been added', 'bp-code-snippets' );
	$comment_added = bp_code_snippets_single_add_comment($id_snippet, $bp->loggedin_user->id, $comment, $_POST['num_comment']);
	if($comment_added["result"]==0){
		$type_message = "error";
		$message = __('OOps, something went wrong, please try again.', 'bp-code-snippets');
	}
	elseif($comment_added["result"]==2){
		$type_message = "error";
		$message = __('OOps, you added a comment less than 30 seconds ago. Please try again later', 'bp-code-snippets');
	}
	else{
		$snippet = bp_code_snippets_single_code($id_snippet,1);
	}
}
if(isset($_GET['paged'])){
	$paged = intval($_GET['paged']);
}
if(isset($_GET['del_com'])){
	//delete comment
	$comment_deleted = bp_code_snippets_remove_comment($_GET['del_com'], $snippet->cs_comment_count, $id_snippet);
	if($comment_deleted!=1){
		$type_message = "error";
		$message = __('OOps, something went wrong, please try again.', 'bp-code-snippets');
	}
	else{
		$type_message = "updated";
		$message = __('Success : the comment has been removed', 'bp-code-snippets');
	}
}
?>
<script type="text/javascript">
	function verif_comment(){
		if(jQuery("#snippet_comment").val().length < 1){
			alert("<?php _e('OOps, You forgot to write something in your comment!', 'bp-code-snippets' );?>");
			jQuery("#snippet_comment").focus();
			return false;
		}
		return true;
	}
	function pleaseconfirm(url){
		c = confirm("<?php _e('Are you sure you want to do this ?','bp-code-snippets');?>");
		if(c){
			location.href=url;
		}
	}
</script>
<?php if($message):?>
<div id="message" class="<?php echo $type_message;?> fade"><p><?php echo $message;?></p></div>
<?php endif;?>
<?php if($snippet):?>
<div id="snippet_single">
	<div id="single-cs-header">
		<div class="avatar-cs-author">
			<a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" title="<?php echo $user_info->user_nicename;?>" rel="nofollow">
			<?php echo bp_core_fetch_avatar('item_id=' . $snippet->id_user . '&type=full&width=64&height=64' ) ?>
			</a>
		</div>
		<div id="single_cs_meta">
			<span class="highlight"><?php _e('Added by', 'bp-code-snippets');?> <a href="<?php echo site_url() ?>/<?php echo BP_MEMBERS_SLUG ;?>/<?php echo $user_info->user_nicename;?>" rel="nofollow">@<?php echo $user_info->user_nicename;?></a></span>&nbsp;<?php _e('on', 'bp-code-snippets');?> <?php echo mysql2date(get_option('date_format'), $snippet->date_cs);?>&nbsp;<?php _e('at', 'bp-code-snippets');?>&nbsp;<?php echo mysql2date(get_option('time_format'), $snippet->date_cs);?> <?php _e('in category', 'bp-code-snippets');?> <a href="<?php echo $current_url;?>?cat=<?php echo $snippet->snippet_type;?>"><img src="<?php echo BP_CS_PLUGIN_URL;?>/images/<?php echo $snippet->snippet_type;?>.gif" alt="<?php echo $snippet->snippet_type;?>"/>&nbsp;<i><?php echo strtoupper($snippet->snippet_type);?></i></a>
			<h2><?php echo stripslashes($snippet->snippet_title);?></h2>
		</div>
	</div>
	<div id="single_cs_content">
		<div id="single_cs_purpose">
			<p><?php echo stripslashes($snippet->snippet_purpose);?></p>
		</div>
		<div class="code_in_content">	
			<pre class="brush: <?php echo $snippet->snippet_type;?>"><?php echo stripslashes($snippet->snippet_content);?></pre>
		</div>
	</div>
</div>
<div id="cs-comment-list">
	<h3><?php _e('Comments list','bp-code-snippets');?></h3>
	<?php bp_code_snippets_single_list_comments($id_snippet,$paged);?>
</div>
<?php if($bp->groups->current_group->is_user_member):?>
<div id="new-comment-cs">
	<h3><?php _e('Add a new comment to this snippet','bp-code-snippets');?></h3>
	<form id="new_cs_comment" action="" name="new_cs_comment" method="POST" class="standard-form" onsubmit="return verif_comment();">
		<input type="hidden" id="snippet_cc_id" name="snippet_cc_id" value="<?php echo $snippet->id_cs;?>"/>
		<input type="hidden" id="pre-type" name="pre-type" value="<?php echo $snippet->snippet_type;?>"/>
		<input type="hidden" id="num_comment" name="num_comment" value="<?php echo $snippet->cs_comment_count;?>"/>
		<label for="snippet_comment"><?php _e('Your Comment', 'bp-code-snippets' );?>&nbsp;<small><?php _e('(Tags allowed : b, a, em, i, strong, u)','bp-code-snippets');?>&nbsp;<?php _e('To add some code in your comment : use [pre]your code[/pre].','bp-code-snippets');?></small></label>
		<textarea id="snippet_comment" name="snippet_comment"></textarea><br/>
		<input type="submit" name="save_comment" value="<?php _e('Publish your comment', 'bp-code-snippets' );?>"/>
	</form>
</div>
<?php endif;?>
<script type="text/javascript">
     SyntaxHighlighter.all()
</script>
<?php else:?>
	<div id="message" class="error fade"><p><?php _e('OOps, looks like the snippet does not exist anymore!', 'bp-code-snippets');?></p></div>
<?php endif;?>